Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2117)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! OpenACC directives and related code removed
 ! 
 ! Former revisions:
@@ -163,5 +163,5 @@
 !>
 !> @todo (re)move large_scale_forcing actions
-!> @todo check/optimize OpenMP and OpenACC directives
+!> @todo check/optimize OpenMP directives
 !------------------------------------------------------------------------------!
  MODULE surface_layer_fluxes_mod
@@ -472,5 +472,4 @@
 
        !$OMP PARALLEL DO PRIVATE( k )
-       !$acc kernels loop present( nzb_s_inner, u, uv_total, v ) private( j, k )
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -492,7 +491,5 @@
 !
 !--    Values of uv_total need to be exchanged at the ghost boundaries
-       !$acc update host( uv_total )
        CALL exchange_horiz_2d( uv_total )
-       !$acc update device( uv_total )
 
     END SUBROUTINE calc_uv_total
@@ -522,8 +519,5 @@
        IF ( TRIM( most_method ) /= 'circular' )  THEN
       
-          !$acc data present( nzb_s_inner, pt, q, qsws, rib, shf, uv_total, vpt, zu, zw )
-
           !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          !$acc kernels loop private( j, k, z_mo )
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -564,5 +558,4 @@
              ENDDO
           ENDDO 
-          !$acc end data
 
        ENDIF
@@ -574,7 +567,4 @@
 
           !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          !# WARNING: does not work on GPU so far because of DO-loop with
-          !#          undetermined iterations
-          !!!!!!$acc kernels loop
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -695,6 +685,4 @@
 
           !$OMP PARALLEL DO PRIVATE( k, l, z_mo ) FIRSTPRIVATE( l_bnd ) LASTPRIVATE( l_bnd )
-          !# WARNING: does not work on GPU so far because of DO  WHILE construct
-          !!!!!!$acc kernels loop
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -736,5 +724,4 @@
 
           !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          !$acc kernels loop present( nzb_s_inner, ol, pt, pt1, q, ql, qs, qv1, ts, us, vpt, zu, zw ) private( j, k, z_mo )
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -775,7 +762,5 @@
 !--    Values of ol at ghost point locations are needed for the evaluation
 !--    of usws and vsws.
-       !$acc update host( ol )
        CALL exchange_horiz_2d( ol )
-       !$acc update device( ol )
 
     END SUBROUTINE calc_ol
@@ -788,5 +773,4 @@
 
        !$OMP PARALLEL DO PRIVATE( k, z_mo )
-       !$acc kernels loop present( nzb_s_inner, ol, us, uv_total, zu, zw, z0 ) private( j, k, z_mo )
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -811,5 +795,4 @@
        IMPLICIT NONE
 
-       !$acc kernels loop present( nzb_s_inner, pt, pt1, pt_d_t, q, ql, qv1 ) private( j, k )
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -828,9 +811,4 @@
        IMPLICIT NONE
 
-!
-!--    Data information for accelerators
-       !$acc data present( e, nrsws, nzb_u_inner, nzb_v_inner, nzb_s_inner, pt )  &
-       !$acc      present( q, qs, qsws, qrsws, shf, ts, u, us, usws, v )     &
-       !$acc      present( vpt, vsws, zu, zw, z0, z0h )
 ! 
 !--    Compute theta*
@@ -840,5 +818,4 @@
 !--       For a given heat flux in the surface layer:
           !$OMP PARALLEL DO
-          !$acc kernels loop private( j, k )
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -858,5 +835,4 @@
           IF ( large_scale_forcing  .AND.  lsf_surf )  THEN
              !$OMP PARALLEL DO
-             !$acc kernels loop private( j, k )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
@@ -868,5 +844,4 @@
 
           !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          !$acc kernels loop present( nzb_s_inner, ol, pt, pt1, ts, zu, zw, z0h ) private( j, k, z_mo )
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -898,5 +873,4 @@
 !--          For a given water flux in the surface layer
              !$OMP PARALLEL DO
-             !$acc kernels loop private( j )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
@@ -912,5 +886,4 @@
              IF ( large_scale_forcing  .AND.  lsf_surf )  THEN
                 !$OMP PARALLEL DO
-                !$acc kernels loop private( j, k )
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
@@ -922,7 +895,5 @@
 
              !$OMP PARALLEL DO PRIVATE( e_s, k, z_mo )
-             !$acc kernels loop independent present( nzb_s_inner, ol, pt, q, qs, qv1, zu, zw, z0q ) private( e_s, j, k, z_mo )
              DO  i = nxlg, nxrg
-                !$acc loop independent
                 DO  j = nysg, nyng
 
@@ -965,5 +936,4 @@
 !--          For a given water flux in the surface layer
              !$OMP PARALLEL DO
-             !$acc kernels loop private( j )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
@@ -981,7 +951,5 @@
 
           !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          !$acc kernels loop independent present( nr, nrs, nzb_s_inner, ol, qr, qrs, zu, zw, z0q ) private( j, k, z_mo )
           DO  i = nxlg, nxrg
-             !$acc loop independent
              DO  j = nysg, nyng
 
@@ -1002,5 +970,4 @@
 
        ENDIF
-       !$acc end data
 
     END SUBROUTINE calc_scaling_parameters
@@ -1020,5 +987,4 @@
 !--    First compute the corresponding component of u* and square it.
        !$OMP PARALLEL DO PRIVATE( k, ol_mid, z_mo )
-       !$acc kernels loop present( nzb_u_inner, ol, u, us, usws, zu, zw, z0 ) private( j, k, z_mo )
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -1048,5 +1014,4 @@
 !--    First compute the corresponding component of u* and square it.
        !$OMP PARALLEL DO PRIVATE( k, ol_mid, z_mo )
-       !$acc kernels loop present( nzb_v_inner, ol, v, us, vsws, zu, zw, z0 ) private( j, k, ol_mid, z_mo )
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -1075,8 +1040,6 @@
 !
 !--    Exchange the boundaries for the momentum fluxes (is this still required?)
-       !$acc update host( usws, vsws )
        CALL exchange_horiz_2d( usws )
        CALL exchange_horiz_2d( vsws )
-       !$acc update device( usws, vsws )
 
 !
@@ -1086,7 +1049,5 @@
             .NOT.  urban_surface )  THEN
           !$OMP PARALLEL DO
-          !$acc kernels loop independent present( shf, ts, us )
           DO  i = nxlg, nxrg
-             !$acc loop independent
              DO  j = nysg, nyng
                 k   = nzb_s_inner(j,i)
@@ -1103,7 +1064,5 @@
             .OR.  .NOT.  land_surface ) )  THEN
           !$OMP PARALLEL DO
-          !$acc kernels loop independent present( qs, qsws, us )
           DO  i = nxlg, nxrg
-             !$acc loop independent
              DO  j = nysg, nyng
                 k   = nzb_s_inner(j,i)
@@ -1120,7 +1079,5 @@
             .OR.  .NOT.  land_surface ) )  THEN
           !$OMP PARALLEL DO
-          !$acc kernels loop independent present( qs, qsws, us )
           DO  i = nxlg, nxrg
-             !$acc loop independent
              DO  j = nysg, nyng
                 ssws(j,i) = -ss(j,i) * us(j,i)
@@ -1134,7 +1091,5 @@
        IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
           !$OMP PARALLEL DO
-          !$acc kernels loop independent present( nrs, nrsws, qrs, qrsws, us )
           DO  i = nxlg, nxrg
-             !$acc loop independent
              DO  j = nysg, nyng
                 qrsws(j,i) = -qrs(j,i) * us(j,i)
@@ -1148,7 +1103,5 @@
        IF ( ibc_e_b == 2 )  THEN
           !$OMP PARALLEL DO
-          !$acc kernels loop independent present( e, nzb_s_inner, us )
           DO  i = nxlg, nxrg
-             !$acc loop independent
              DO  j = nysg, nyng
                 k = nzb_s_inner(j,i)
Index: /palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- /palm/trunk/SOURCE/swap_timelevel.f90	(revision 2117)
+++ /palm/trunk/SOURCE/swap_timelevel.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! OpenACC directives removed
 ! 
 ! Former revisions:
@@ -142,10 +142,6 @@
     CALL cpu_log( log_point(28), 'swap_timelevel (nop)', 'start' )
 
-    !$acc kernels present( pt, pt_p, u, u_p, v, v_p, w, w_p )
-    !$acc loop independent
     DO  i = nxlg, nxrg
-       !$acc loop independent
        DO  j = nysg, nyng
-          !$acc loop independent
           DO  k = nzb, nzt+1
              u(k,j,i)  = u_p(k,j,i)
@@ -156,16 +152,8 @@
        ENDDO
     ENDDO
-!    u  = u_p
-!    v  = v_p
-!    w  = w_p
-!    pt = pt_p
-    !$acc end kernels
+
     IF ( .NOT. constant_diffusion )  THEN
-       !$acc kernels present( e, e_p )
-       !$acc loop independent
        DO  i = nxlg, nxrg
-          !$acc loop independent
           DO  j = nysg, nyng
-             !$acc loop independent
              DO  k = nzb, nzt+1
                 e(k,j,i) = e_p(k,j,i)
@@ -173,10 +161,10 @@
           ENDDO
        ENDDO
-!       e = e_p
-       !$acc end kernels
-    ENDIF
+    ENDIF
+
     IF ( ocean )  THEN
        sa = sa_p
     ENDIF
+
     IF ( humidity )  THEN
        q = q_p             
@@ -186,4 +174,5 @@
        ENDIF
     ENDIF
+
     IF ( passive_scalar )  s = s_p             
 
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 2117)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! OpenACC directives and related code removed
 ! 
 ! Former revisions:
@@ -273,5 +273,5 @@
                microphysics_seifert, mid, nest_domain,                         &
                neutral, nr_timesteps_this_run, nudging,                        &
-               ocean, on_device, passive_scalar,                               &
+               ocean, passive_scalar,                                          &
                prho_reference, pt_reference, pt_slope_offset, random_heatflux, &
                run_coupled, simulated_time, simulated_time_chr,                &
@@ -298,6 +298,6 @@
 
     USE indices,                                                               &
-        ONLY:  i_left, i_right, j_north, j_south, nbgp, nx, nxl, nxlg, nxr,    &
-               nxrg, nyn, nyng, nys, nysg, nzb, nzt, nzb_u_inner, nzb_v_inner
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt, &
+               nzb_u_inner, nzb_v_inner
 
     USE interaction_droplets_ptq_mod,                                          &
@@ -338,6 +338,5 @@
 
     USE prognostic_equations_mod,                                              &
-        ONLY:  prognostic_equations_acc, prognostic_equations_cache,           &
-               prognostic_equations_vector
+        ONLY:  prognostic_equations_cache, prognostic_equations_vector
 
     USE radiation_model_mod,                                                   &
@@ -522,155 +521,4 @@
           ELSEIF ( loop_optimization == 'vector' )  THEN
              CALL prognostic_equations_vector
-          ELSEIF ( loop_optimization == 'acc' )  THEN
-             i_left  = nxl;         i_right = nxr
-             j_south = nys;         j_north = nyn
-             CALL prognostic_equations_acc
-
-!             i_left  = nxl;         i_right = nxl+nbgp-1
-!             j_south = nys;         j_north = nyn
-!             CALL prognostic_equations_acc
-!             i_left  = nxr-nbgp+1;  i_right = nxr
-!             j_south = nys;         j_north = nyn
-!             CALL prognostic_equations_acc
-
-!
-!--          Exchange of ghost points (lateral boundary conditions)
-             IF ( background_communication )  THEN
-
-                CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'start' )
-                
-                send_receive = 'lr'
-                sendrecv_in_background = .TRUE.
-                req          = 0
-                req_count    = 0
-
-                IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
-                   on_device = .TRUE.         ! to be removed after complete porting
-                ELSE                          ! of ghost point exchange
-                   !$acc update host( e_p, pt_p, u_p, v_p, w_p )
-                ENDIF
-
-                CALL exchange_horiz( u_p, nbgp )
-                CALL exchange_horiz( v_p, nbgp )
-                CALL exchange_horiz( w_p, nbgp )
-                CALL exchange_horiz( pt_p, nbgp )
-                IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e_p, nbgp )
-                IF ( ocean )  THEN
-                   CALL exchange_horiz( sa_p, nbgp )
-                   CALL exchange_horiz( rho_ocean, nbgp )
-                   CALL exchange_horiz( prho, nbgp )
-                ENDIF
-                IF ( humidity )  THEN
-                   CALL exchange_horiz( q_p, nbgp )
-                   IF ( cloud_physics .AND. microphysics_seifert )  THEN
-                      CALL exchange_horiz( qr_p, nbgp )
-                      CALL exchange_horiz( nr_p, nbgp )
-                   ENDIF
-                ENDIF
-                IF ( cloud_droplets )  THEN
-                   CALL exchange_horiz( ql, nbgp )
-                   CALL exchange_horiz( ql_c, nbgp )
-                   CALL exchange_horiz( ql_v, nbgp )
-                   CALL exchange_horiz( ql_vp, nbgp )
-                ENDIF
-                IF ( wang_kernel  .OR.  collision_turbulence  .OR.             &
-                     use_sgs_for_particles )  THEN
-                   CALL exchange_horiz( diss, nbgp )
-                ENDIF
-                IF ( passive_scalar )  CALL exchange_horiz( s_p, nbgp )
-
-                IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
-                   on_device = .FALSE.        ! to be removed after complete porting
-                ELSE                          ! of ghost point exchange
-                   !$acc update device( e_p, pt_p, u_p, v_p, w_p )
-                ENDIF
-
-                sendrecv_in_background = .FALSE.
-
-                CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'pause' )
-
-             ENDIF
-
-!             i_left  = nxl+nbgp;    i_right = nxr-nbgp
-!             j_south = nys;         j_north = nys+nbgp-1
-!             CALL prognostic_equations_acc
-!             i_left  = nxl+nbgp;    i_right = nxr-nbgp
-!             j_south = nyn-nbgp+1;  j_north = nyn
-!             CALL prognostic_equations_acc
-
-             IF ( background_communication )  THEN
-                CALL cpu_log( log_point(41), 'exchange-horiz-wait', 'start' )
-#if defined( __parallel )
-                CALL MPI_WAITALL( req_count, req, wait_stat, ierr )
-#endif
-                CALL cpu_log( log_point(41), 'exchange-horiz-wait', 'pause' )
-
-                CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'continue' )
-
-                send_receive = 'ns'
-                sendrecv_in_background = .TRUE.
-                req          = 0
-                req_count    = 0
-
-                IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
-                   on_device = .TRUE.         ! to be removed after complete porting
-                ELSE                          ! of ghost point exchange
-                   !$acc update host( e_p, pt_p, u_p, v_p, w_p )
-                ENDIF
-
-                CALL exchange_horiz( u_p, nbgp )
-                CALL exchange_horiz( v_p, nbgp )
-                CALL exchange_horiz( w_p, nbgp )
-                CALL exchange_horiz( pt_p, nbgp )
-                IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e_p, nbgp )
-                IF ( ocean )  THEN
-                   CALL exchange_horiz( sa_p, nbgp )
-                   CALL exchange_horiz( rho_ocean, nbgp )
-                  CALL exchange_horiz( prho, nbgp )
-                ENDIF
-                IF ( humidity )  THEN
-                   CALL exchange_horiz( q_p, nbgp )
-                   IF ( cloud_physics .AND. microphysics_seifert )  THEN
-                      CALL exchange_horiz( qr_p, nbgp )
-                      CALL exchange_horiz( nr_p, nbgp )
-                   ENDIF
-                ENDIF
-                IF ( cloud_droplets )  THEN
-                   CALL exchange_horiz( ql, nbgp )
-                   CALL exchange_horiz( ql_c, nbgp )
-                   CALL exchange_horiz( ql_v, nbgp )
-                   CALL exchange_horiz( ql_vp, nbgp )
-                ENDIF
-                IF ( wang_kernel  .OR.  collision_turbulence  .OR.             &
-                     use_sgs_for_particles )  THEN
-                   CALL exchange_horiz( diss, nbgp )
-                ENDIF
-                IF ( passive_scalar )  CALL exchange_horiz( s_p, nbgp )
-
-                IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
-                   on_device = .FALSE.        ! to be removed after complete porting
-                ELSE                          ! of ghost point exchange
-                   !$acc update device( e_p, pt_p, u_p, v_p, w_p )
-                ENDIF
-
-                sendrecv_in_background = .FALSE.
-
-                CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'stop' )
-
-             ENDIF
-
-!             i_left  = nxl+nbgp;    i_right = nxr-nbgp
-!             j_south = nys+nbgp;    j_north = nyn-nbgp
-!             CALL prognostic_equations_acc
-
-             IF ( background_communication )  THEN
-                CALL cpu_log( log_point(41), 'exchange-horiz-wait', 'continue' )
-#if defined( __parallel )
-                CALL MPI_WAITALL( req_count, req, wait_stat, ierr )
-#endif
-                send_receive = 'al'
-                CALL cpu_log( log_point(41), 'exchange-horiz-wait', 'stop' )
-             ENDIF
-
           ENDIF
 
@@ -699,52 +547,36 @@
 !
 !--       Exchange of ghost points (lateral boundary conditions)
-          IF ( .NOT. background_communication )  THEN
-
-             CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'start' )
-
-             IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
-                on_device = .TRUE.         ! to be removed after complete porting
-             ELSE                          ! of ghost point exchange
-                !$acc update host( e_p, pt_p, u_p, v_p, w_p )
-             ENDIF
-
-             CALL exchange_horiz( u_p, nbgp )
-             CALL exchange_horiz( v_p, nbgp )
-             CALL exchange_horiz( w_p, nbgp )
-             CALL exchange_horiz( pt_p, nbgp )
-             IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e_p, nbgp )
-             IF ( ocean )  THEN
-                CALL exchange_horiz( sa_p, nbgp )
-                CALL exchange_horiz( rho_ocean, nbgp )
-                CALL exchange_horiz( prho, nbgp )
-             ENDIF
-             IF ( humidity )  THEN
-                CALL exchange_horiz( q_p, nbgp )
-                IF ( cloud_physics .AND. microphysics_seifert )  THEN
-                   CALL exchange_horiz( qr_p, nbgp )
-                   CALL exchange_horiz( nr_p, nbgp )
-                ENDIF
-             ENDIF
-             IF ( cloud_droplets )  THEN
-                CALL exchange_horiz( ql, nbgp )
-                CALL exchange_horiz( ql_c, nbgp )
-                CALL exchange_horiz( ql_v, nbgp )
-                CALL exchange_horiz( ql_vp, nbgp )
-             ENDIF
-             IF ( wang_kernel  .OR.  collision_turbulence  .OR.                &
-                  use_sgs_for_particles )  THEN
-                CALL exchange_horiz( diss, nbgp )
-             ENDIF
-             IF ( passive_scalar )  CALL exchange_horiz( s_p, nbgp )      
-
-             IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
-                on_device = .FALSE.        ! to be removed after complete porting
-             ELSE                          ! of ghost point exchange
-                !$acc update device( e_p, pt_p, u_p, v_p, w_p )
-             ENDIF
-
-             CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'stop' )
-
-          ENDIF
+          CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'start' )
+
+          CALL exchange_horiz( u_p, nbgp )
+          CALL exchange_horiz( v_p, nbgp )
+          CALL exchange_horiz( w_p, nbgp )
+          CALL exchange_horiz( pt_p, nbgp )
+          IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e_p, nbgp )
+          IF ( ocean )  THEN
+             CALL exchange_horiz( sa_p, nbgp )
+             CALL exchange_horiz( rho_ocean, nbgp )
+             CALL exchange_horiz( prho, nbgp )
+          ENDIF
+          IF ( humidity )  THEN
+             CALL exchange_horiz( q_p, nbgp )
+             IF ( cloud_physics .AND. microphysics_seifert )  THEN
+                CALL exchange_horiz( qr_p, nbgp )
+                CALL exchange_horiz( nr_p, nbgp )
+             ENDIF
+          ENDIF
+          IF ( cloud_droplets )  THEN
+             CALL exchange_horiz( ql, nbgp )
+             CALL exchange_horiz( ql_c, nbgp )
+             CALL exchange_horiz( ql_v, nbgp )
+             CALL exchange_horiz( ql_vp, nbgp )
+          ENDIF
+          IF ( wang_kernel  .OR.  collision_turbulence  .OR.                &
+               use_sgs_for_particles )  THEN
+             CALL exchange_horiz( diss, nbgp )
+          ENDIF
+          IF ( passive_scalar )  CALL exchange_horiz( s_p, nbgp )
+
+          CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'stop' )
 
 !
@@ -821,6 +653,4 @@
              time_disturb = time_disturb + dt_3d
              IF ( time_disturb >= dt_disturb )  THEN
-                !$acc update host( u, v )
-                IF ( numprocs == 1 )  on_device = .FALSE.  ! workaround, remove later
                 IF ( disturbance_energy_limit /= 0.0_wp  .AND.                 &
                      hom(nzb+5,1,pr_palm,0) < disturbance_energy_limit )  THEN
@@ -836,6 +666,4 @@
                    dist_range = 0
                 ENDIF
-                IF ( numprocs == 1 )  on_device = .TRUE.  ! workaround, remove later
-                !$acc update device( u, v )
                 time_disturb = time_disturb - dt_disturb
              ENDIF
@@ -854,5 +682,4 @@
           IF ( cloud_physics )  THEN
              CALL calc_liquid_water_content
-             !$acc update device( ql )
           ENDIF
 ! 
@@ -860,5 +687,4 @@
           IF ( humidity )  THEN 
              CALL compute_vpt 
-             !$acc update device( vpt ) 
           ENDIF 
 
Index: /palm/trunk/SOURCE/timestep.f90
===================================================================
--- /palm/trunk/SOURCE/timestep.f90	(revision 2117)
+++ /palm/trunk/SOURCE/timestep.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! OpenACC directives and related part of code removed
 ! 
 ! Former revisions:
@@ -182,5 +182,4 @@
           u_gtrans_l = 0.0_wp
           v_gtrans_l = 0.0_wp
-          !$acc parallel present( u, v )
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -191,5 +190,4 @@
              ENDDO
           ENDDO
-          !$acc end parallel
           uv_gtrans_l(1) = u_gtrans_l / REAL( (nxr-nxl+1)*(nyn-nys+1)*(nzt-nzb), KIND=wp )
           uv_gtrans_l(2) = v_gtrans_l / REAL( (nxr-nxl+1)*(nyn-nys+1)*(nzt-nzb), KIND=wp )
@@ -210,62 +208,4 @@
 !-- Determine the maxima of the velocity components, including their
 !-- grid index positions.
-#if defined( __openacc )
-    IF ( dt_fixed )  THEN  ! otherwise do it further below for better cache usage
-       u_max_l = -999999.9_wp
-       u_min_l =  999999.9_wp
-       v_max_l = -999999.9_wp
-       v_min_l =  999999.9_wp
-       w_max_l = -999999.9_wp
-       w_min_l =  999999.9_wp
-       !$acc parallel present( u, v, w )
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                u_max_l = MAX( u_max_l, u(k,j,i) )
-                u_min_l = MIN( u_min_l, u(k,j,i) )
-                v_max_l = MAX( v_max_l, v(k,j,i) )
-                v_min_l = MIN( v_min_l, v(k,j,i) )
-                w_max_l = MAX( w_max_l, w(k,j,i) )
-                w_min_l = MIN( w_min_l, w(k,j,i) )
-             ENDDO
-          ENDDO
-       ENDDO
-       !$acc end parallel
-#if defined( __parallel )
-       reduce_l(1) = u_max_l
-       reduce_l(2) = v_max_l
-       reduce_l(3) = w_max_l
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( reduce_l, reduce, 3, MPI_REAL, MPI_MAX, comm2d, ierr )
-       u_max = reduce(1)
-       v_max = reduce(2)
-       w_max = reduce(3)
-       reduce_l(1) = u_min_l
-       reduce_l(2) = v_min_l
-       reduce_l(3) = w_min_l
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( reduce_l, reduce, 3, MPI_REAL, MPI_MIN, comm2d, ierr )
-       IF ( ABS( reduce(1) ) > u_max )  u_max = reduce(1)
-       IF ( ABS( reduce(2) ) > v_max )  v_max = reduce(2)
-       IF ( ABS( reduce(3) ) > w_max )  w_max = reduce(3)
-#else
-       IF ( ABS( u_min_l ) > u_max_l )  THEN
-          u_max = u_min_l
-       ELSE
-          u_max = u_max_l
-       ENDIF
-       IF ( ABS( v_min_l ) > v_max_l )  THEN
-          v_max = v_min_l
-       ELSE
-          v_max = v_max_l
-       ENDIF
-       IF ( ABS( w_min_l ) > w_max_l )  THEN
-          w_max = w_min_l
-       ELSE
-          w_max = w_max_l
-       ENDIF
-#endif
-    ENDIF
-#else
     CALL global_min_max( nzb, nzt+1, nysg, nyng, nxlg, nxrg, u, 'abs', 0.0_wp, &
                          u_max, u_max_ijk )
@@ -274,88 +214,6 @@
     CALL global_min_max( nzb, nzt+1, nysg, nyng, nxlg, nxrg, w, 'abs', 0.0_wp, &
                          w_max, w_max_ijk )
-#endif
 
     IF ( .NOT. dt_fixed )  THEN
-#if defined( __openacc )
-!
-!--    Variable time step:
-!--    Calculate the maximum time step according to the CFL-criterion,
-!--    individually for each velocity component
-       dt_u_l  =  999999.9_wp
-       dt_v_l  =  999999.9_wp
-       dt_w_l  =  999999.9_wp
-       u_max_l = -999999.9_wp
-       u_min_l =  999999.9_wp
-       v_max_l = -999999.9_wp
-       v_min_l =  999999.9_wp
-       w_max_l = -999999.9_wp
-       w_min_l =  999999.9_wp
-       !$acc parallel loop collapse(3) present( u, v, w )
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                dt_u_l  = MIN( dt_u_l, ( dx     / ( ABS( u(k,j,i) - u_gtrans ) + 1.0E-10_wp ) ) )
-                dt_v_l  = MIN( dt_v_l, ( dy     / ( ABS( v(k,j,i) - v_gtrans ) + 1.0E-10_wp ) ) )
-                dt_w_l  = MIN( dt_w_l, ( dzu(k) / ( ABS( w(k,j,i) )            + 1.0E-10_wp ) ) )
-                u_max_l = MAX( u_max_l, u(k,j,i) )
-                u_min_l = MIN( u_min_l, u(k,j,i) )
-                v_max_l = MAX( v_max_l, v(k,j,i) )
-                v_min_l = MIN( v_min_l, v(k,j,i) )
-                w_max_l = MAX( w_max_l, w(k,j,i) )
-                w_min_l = MIN( w_min_l, w(k,j,i) )
-             ENDDO
-          ENDDO
-       ENDDO
-       !$acc end parallel
-
-#if defined( __parallel )
-       reduce_l(1) = dt_u_l
-       reduce_l(2) = dt_v_l
-       reduce_l(3) = dt_w_l
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( reduce_l, reduce, 3, MPI_REAL, MPI_MIN, comm2d, ierr )
-       dt_u = reduce(1)
-       dt_v = reduce(2)
-       dt_w = reduce(3)
-
-       reduce_l(1) = u_max_l
-       reduce_l(2) = v_max_l
-       reduce_l(3) = w_max_l
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( reduce_l, reduce, 3, MPI_REAL, MPI_MAX, comm2d, ierr )
-       u_max = reduce(1)
-       v_max = reduce(2)
-       w_max = reduce(3)
-       reduce_l(1) = u_min_l
-       reduce_l(2) = v_min_l
-       reduce_l(3) = w_min_l
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( reduce_l, reduce, 3, MPI_REAL, MPI_MIN, comm2d, ierr )
-       IF ( ABS( reduce(1) ) > u_max )  u_max = reduce(1)
-       IF ( ABS( reduce(2) ) > v_max )  v_max = reduce(2)
-       IF ( ABS( reduce(3) ) > w_max )  w_max = reduce(3)
-#else
-       dt_u = dt_u_l
-       dt_v = dt_v_l
-       dt_w = dt_w_l
-
-       IF ( ABS( u_min_l ) > u_max_l )  THEN
-          u_max = u_min_l
-       ELSE
-          u_max = u_max_l
-       ENDIF
-       IF ( ABS( v_min_l ) > v_max_l )  THEN
-          v_max = v_min_l
-       ELSE
-          v_max = v_max_l
-       ENDIF
-       IF ( ABS( w_min_l ) > w_max_l )  THEN
-          w_max = w_min_l
-       ELSE
-          w_max = w_max_l
-       ENDIF
-#endif
-
-#else
 !
 !--    Variable time step:
@@ -390,6 +248,4 @@
 #endif
 
-#endif
-
 !
 !--    Compute time step according to the diffusion criterion.
@@ -404,7 +260,6 @@
        ENDDO
 
-!$OMP PARALLEL private(i,j,k,value) reduction(MIN: dt_diff_l)
-!$OMP DO
-       !$acc parallel loop collapse(3) present( kh, km )
+       !$OMP PARALLEL private(i,j,k,value) reduction(MIN: dt_diff_l)
+       !$OMP DO
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -415,6 +270,5 @@
           ENDDO
        ENDDO
-       !$acc end parallel
-!$OMP END PARALLEL 
+       !$OMP END PARALLEL
 #if defined( __parallel )
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
